#ifndef _RENDERER_H_
#define _RENDERER_H_
#include <cstdlib>
#include <GL/glut.h>
#include "Core_Mesh/Mesh.h"
#include "Core_Mesh/Loop.h"

namespace XMeshLib
{
	class Renderer
	{

	public:
		Renderer();
		~Renderer(){;}

		void SetMesh(Mesh * inmesh);
		void SetupEye();
		void UpdateEye();
		void InitGL();
		void PrintUsage();

		void ReshapeScene(int w, int h);

		void RenderAll(std::vector<Loop> & boundaryLoops);
		void RenderMesh();
		void RenderEdges(std::vector<Halfedge *> & helist);
		void ComputeMassCenterAndBoundingBox();
		float ComputeNormalAndArea(Face * f, float norm[3]);
		void ComputeNormal(Vertex * ver, float norm[3]);

		void MouseMove(int x, int y);
		void MouseClick(int button , int state, int x, int y);
		void KeyBoard(unsigned char key, int x, int y);

	public:
		float EyePosition[3];
		float DltEye[3];
		float ObjCenter[3];
		float BoxMin[3];
		float BoxMax[3];
		int win_width, win_height;
		int win_x, win_y;
		float whratio;
		int mouseX, mouseY;
		Mesh * cmesh;
		bool needUpdateEye;
		float rot_x, rot_y;
		int gButton;
	};
}
#endif
